/*
	myfunctions.h
    =============

    Contiene i prototipi delle nuove funzioni
	definite ed utilizzate nel coordinatore

*/

DWORD WINAPI WindowThread(int *request_id);
LRESULT CALLBACK Request_Window_Procedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
int GetNewFileId(void);
void AddFileToArray(FILEDES f);
void InitOpenFileStructure(void);
BOOL ValidFloat(char *s);
BOOL CALLBACK NewRequestWindowProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam); 
BOOL CALLBACK MainWindowProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam); 
int GetNewJobId(void);
int GetNewDatagramId(void);
int GetNewRequestId(void);
void AddJobToArray(JOB j);
void *SlaveTable(int Command, SLAVE *sl);
int IndexInRequestArray(unsigned int request_id);
int IndexInJobArray(unsigned int job_id);
int IndexInJobArrayFromAddress(struct in_addr ip);
int IndexInBox(int listbox_id, int id);
void Fail(JOB *Job, int i, SOCKET s, SOCKET tcp_sock, char *txtbuffer);
char *GetFileName(char *fullname);
DWORD WINAPI DoJob(JOB *Job);
int FindSlowestJobToEndIndex(void);
int FindMediumTimeToCompleteJobs(void);
void ControllaElimina(unsigned int request_id);
DWORD WINAPI Scheduler(LPVOID lp);
DWORD WINAPI receiving_thread(SOCKET *s2);		/* Si mette in ascolto su una socket s2, gi inizializzata e bound */